﻿using System;
using TaleWorlds.Library;

namespace gunmod
{
	// Token: 0x02000006 RID: 6
	public struct Vector2
	{
		// Token: 0x17000001 RID: 1
		// (get) Token: 0x0600002D RID: 45 RVA: 0x000030A0 File Offset: 0x000012A0
		public double X { get; }

		// Token: 0x17000002 RID: 2
		// (get) Token: 0x0600002E RID: 46 RVA: 0x000030A8 File Offset: 0x000012A8
		public double Y { get; }

		// Token: 0x0600002F RID: 47 RVA: 0x000030B0 File Offset: 0x000012B0
		public static Vector2 operator +(Vector2 a, Vector2 b)
		{
			return new Vector2(a.X + b.X, a.Y + b.Y);
		}

		// Token: 0x06000030 RID: 48 RVA: 0x000030D5 File Offset: 0x000012D5
		public static Vector2 operator *(double a, Vector2 b)
		{
			return new Vector2(a * b.X, a * b.Y);
		}

		// Token: 0x06000031 RID: 49 RVA: 0x000030EE File Offset: 0x000012EE
		public static Vector2 operator *(int a, Vector2 b)
		{
			return new Vector2((double)a * b.X, (double)a * b.Y);
		}

		// Token: 0x06000032 RID: 50 RVA: 0x00003109 File Offset: 0x00001309
		public static Vector2 operator *(Vector2 b, double a)
		{
			return new Vector2(a * b.X, a * b.Y);
		}

		// Token: 0x06000033 RID: 51 RVA: 0x00003122 File Offset: 0x00001322
		public static Vector2 operator /(Vector2 b, double a)
		{
			return new Vector2(b.X / a, b.Y / a);
		}

		// Token: 0x06000034 RID: 52 RVA: 0x0000313B File Offset: 0x0000133B
		public static Vector2 operator *(Vector2 b, int a)
		{
			return new Vector2((double)a * b.X, (double)a * b.Y);
		}

		// Token: 0x06000035 RID: 53 RVA: 0x00003156 File Offset: 0x00001356
		public static Vector2 operator -(Vector2 a, Vector2 b)
		{
			return new Vector2(a.X - b.X, a.Y - b.Y);
		}

		// Token: 0x06000036 RID: 54 RVA: 0x0000317B File Offset: 0x0000137B
		public static implicit operator Vec2(Vector2 vector2)
		{
			return new Vec2((float)vector2.X, (float)vector2.Y);
		}

		// Token: 0x06000037 RID: 55 RVA: 0x00003192 File Offset: 0x00001392
		public static Vector2 operator -(Vector2 a)
		{
			return new Vector2(-a.X, -a.Y);
		}

		// Token: 0x06000038 RID: 56 RVA: 0x000031AC File Offset: 0x000013AC
		public double distance(Vector2 v2)
		{
			return (this - v2).value();
		}

		// Token: 0x06000039 RID: 57 RVA: 0x000031CD File Offset: 0x000013CD
		public double product(Vector2 v2)
		{
			return v2.X * this.X + v2.Y * this.Y;
		}

		// Token: 0x0600003A RID: 58 RVA: 0x000031EC File Offset: 0x000013EC
		public double cos(Vector2 v2)
		{
			return this.product(v2) / this.value() / v2.value();
		}

		// Token: 0x0600003B RID: 59 RVA: 0x00003204 File Offset: 0x00001404
		public double value()
		{
			return Math.Sqrt(this.X * this.X + this.Y * this.Y);
		}

		// Token: 0x0600003C RID: 60 RVA: 0x00003226 File Offset: 0x00001426
		public Vector2 nolrmalized()
		{
			if (this.value() != 0.0)
			{
				return new Vector2(this.X / this.value(), this.Y / this.value());
			}
			return new Vector2(0, 0);
		}

		// Token: 0x0600003D RID: 61 RVA: 0x00003260 File Offset: 0x00001460
		public Vector2(double x, double y)
		{
			this.X = x;
			this.Y = y;
		}

		// Token: 0x0600003E RID: 62 RVA: 0x00003270 File Offset: 0x00001470
		public Vector2(int x, int y)
		{
			this.X = (double)x;
			this.Y = (double)y;
		}

		// Token: 0x0600003F RID: 63 RVA: 0x00003284 File Offset: 0x00001484
		public string pos()
		{
			return string.Concat(new string[]
			{
				"(",
				this.X.ToString(),
				",",
				this.Y.ToString(),
				")"
			});
		}
	}
}
