﻿using System;
using System.Collections.Generic;
using TaleWorlds.Core;
using TaleWorlds.MountAndBlade;

namespace gunmod
{
	// Token: 0x02000009 RID: 9
	internal class shootTogether
	{
		// Token: 0x0600006B RID: 107 RVA: 0x00003D68 File Offset: 0x00001F68
		public static void onAndoff(FormationClass formation)
		{
			foreach (shootTogether shootTogether in shootTogether.shootTogethers)
			{
				if (shootTogether.fc == formation)
				{
					shootTogether.allowShoot = !shootTogether.allowShoot;
					if (shootTogether.allowShoot)
					{
						if (Agent.Main != null && Agent.Main.IsActive())
						{
							Agent.Main.sayFireAtWill();
						}
						helper.playtext(formation.chineseString() + "开火");
						shootTogether.agents.FireAtWill();
						shootTogether.shortTimeAllow = true;
						shootTogether.timer = 0f;
					}
					else
					{
						if (Agent.Main != null && Agent.Main.IsActive())
						{
							Agent.Main.sayHoldfire();
						}
						helper.playtext(formation.chineseString() + "不允许开火");
						shootTogether.agents.HoldFire();
					}
				}
			}
		}

		// Token: 0x0600006C RID: 108 RVA: 0x00003E6C File Offset: 0x0000206C
		public static void OnTick(float dt)
		{
			List<shootTogether> list = new List<shootTogether>();
			foreach (shootTogether shootTogether in shootTogether.shootTogethers)
			{
				if (Mission.Current != null && shootTogether.mission == Mission.Current)
				{
					shootTogether.onTick(dt);
				}
				else
				{
					list.Add(shootTogether);
				}
			}
			foreach (shootTogether item in list)
			{
				shootTogether.shootTogethers.Remove(item);
			}
		}

		// Token: 0x0600006D RID: 109 RVA: 0x00003F24 File Offset: 0x00002124
		public void updateagents()
		{
			w.Write("updateagents_start");
			this.agents = new List<Agent>();
			foreach (Agent agent in this.mission.AllAgents)
			{
				if (agent != null && !agent.IsMainAgent && agent.Formation != null && agent.Formation.Index ==(int) this.fc && agent.isUsingBow())
				{
					this.agents.Add(agent);
				}
			}
			this.allow = new List<bool>();
			for (int i = 0; i < this.agents.Count; i++)
			{
				this.allow.Add(false);
			}
			w.Write("updateagents_end");
		}

		// Token: 0x0600006E RID: 110 RVA: 0x00003FF8 File Offset: 0x000021F8
		public static void add(Mission mission, FormationClass formation)
		{
			shootTogether shootTogether = null;
			foreach (shootTogether shootTogether2 in shootTogether.shootTogethers)
			{
				if (shootTogether2.fc == formation)
				{
					shootTogether = shootTogether2;
				}
			}
			if (shootTogether != null)
			{
				shootTogether.agents.FireAtWill();
				shootTogether.shootTogethers.Remove(shootTogether);
				helper.playtext(formation.chineseString() + "关闭齐射");
				return;
			}
			shootTogether.shootTogethers.Add(new shootTogether(mission, formation));
			helper.playtext(formation.chineseString() + "开启齐射");
		}

		// Token: 0x0600006F RID: 111 RVA: 0x000040A8 File Offset: 0x000022A8
		public shootTogether(Mission mission, FormationClass formation)
		{
			this.fc = formation;
			this.mission = mission;
			this.updateagents();
			this.allowShoot = true;
		}

		// Token: 0x06000070 RID: 112 RVA: 0x000040E8 File Offset: 0x000022E8
		public void onTick(float dt)
		{
			if (this.shortTimeAllow)
			{
				this.timer += dt;
				if (this.timer > shootTogether.fireTime)
				{
					this.shortTimeAllow = false;
					this.timer = 0f;
				}
			}
			this.ticker++;
			for (int i = 0; i < this.agents.Count; i++)
			{
				if (!this.shortTimeAllow)
				{
					if (!this.allow[i])
					{
						if (this.agents[i].isReadyToShoot())
						{
							this.agents[i].HoldFire();
						}
						else
						{
							this.agents[i].FireAtWill();
						}
					}
					else
					{
						if (this.allowShoot)
						{
							this.agents[i].FireAtWill();
						}
						if (!this.agents[i].notShootYet())
						{
							this.allow[i] = false;
						}
					}
				}
			}
			if (this.ticker > 99)
			{
				this.ticker = 0;
				if (this.agents.isAlmostReadyToShoot((double)shootTogether.rate))
				{
					this.setFire();
				}
			}
		}

		// Token: 0x06000071 RID: 113 RVA: 0x0000420C File Offset: 0x0000240C
		private void setFire()
		{
			for (int i = 0; i < this.allow.Count; i++)
			{
				this.allow[i] = true;
			}
		}

		// Token: 0x04000012 RID: 18
		public static float rate = 0.95f;

		// Token: 0x04000013 RID: 19
		public static float fireTime = 2f;

		// Token: 0x04000014 RID: 20
		private float timer;

		// Token: 0x04000015 RID: 21
		public static List<shootTogether> shootTogethers = new List<shootTogether>();

		// Token: 0x04000016 RID: 22
		private FormationClass fc;

		// Token: 0x04000017 RID: 23
		private Mission mission;

		// Token: 0x04000018 RID: 24
		private List<Agent> agents = new List<Agent>();

		// Token: 0x04000019 RID: 25
		private List<bool> allow = new List<bool>();

		// Token: 0x0400001A RID: 26
		private bool allowShoot = true;

		// Token: 0x0400001B RID: 27
		private bool shortTimeAllow;

		// Token: 0x0400001C RID: 28
		private int ticker;
	}
}
